<template>
  <div>
    <BarChart :chart-data="datacollection" :options="options" :height="300" />
  </div>
</template>

<script>
import BarChart from '@/components/chart/bar.js'
import covertDate from '@/mixins/formateDate'
import axios from 'axios'
export default {
  mixins: [covertDate],
  components: {
    BarChart,
  },
  props: {
    amountWeek: Number,
  },
  data() {
    return {
      datacollection: null,
      options: null,
      setTotalData: [],
      setDateLabel: [],
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    getdashboardTime(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountWeek
      )
    },
    amountWeek(newVal, oldVal) {
      this.getDataAxios(
        this.$nuxt.$store.state.template.dashboardTime,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType,
        this.amountWeek
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.setDateLabel,
        datasets: this.setTotalData,
      }
      this.options = {
        labels: true,
        responsive: true,
        maintainAspectRatio: false,
        height: '250',
        scales: {
          yAxes: [
            {
              ticks: {
                beginAtZero: true,
                min: 0,
                stepSize: 20,
                display: true,
              },
              gridLines: {
                display: true,
              },
            },
          ],
          xAxes: [
            {
              ticks: {
                display: true,
                beginAtZero: true,
              },
              gridLines: {
                display: true,
              },
            },
          ],
        },
        plugins: {
          stacked100: { enable: true },
          datalabels: {
            formatter: function (value) {
              if (value == 0) {
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },
        responsive: true,
        maintainAspectRatio: false,
      }
    },
    async getDataAxios(
      timeVal = new Date(),
      expensestable = 0,
      expensestype = 0,
      amountWeek = 0
    ) {
      if (expensestable) {
        const dateNow = new Date(timeVal)
        const weekNow = dateNow.getDay()
        const oneDay = 86400000

        const amountBar = amountWeek

        const dayStart =
          dateNow.getTime() -
          oneDay * weekNow -
          7 * Math.floor(amountBar / 2) * oneDay // วันที่เลือก - (1วัน * วันของสัปดาห์ 0-6 )
        const dayEnd =
          7 * Math.floor(amountBar / 2) * oneDay +
          (dateNow.getTime() + oneDay * (6 - weekNow))

        const dataRes = this.totalTypeMulti(expensestable, dayStart, dayEnd)

        const labelName = expensestype.map((x) => x.name)
        const countName = expensestype.map((x) => x.name).length

        const checkdate = this.onefunction(7, dayEnd, dayStart)
        const changeDate = this.formateWeek(dataRes, dayEnd, dayStart)

        const getArray = this.setArray(dataRes, countName, amountBar, checkdate)
        const getObject = this.setObject(getArray, countName, labelName)

        this.setTotalData = getObject
        this.setDateLabel = changeDate

        this.fillData()
      }
    },
    setArray(objData, coutName, amountBar, checkdate) {
      const arrayDeserts = new Array(coutName)
      for (let i = 0; i < arrayDeserts.length; i++) {
        arrayDeserts[i] = new Array(2)
      }

      // Loop to initilize 2D array elements.
      for (let i = 0; i < coutName; i++) {
        for (let j = 0; j < amountBar; j++) {
          objData.forEach((res) => {
            if (res.id - 1 == i) {
              if (res.date >= checkdate[j] && res.date < checkdate[j + 1]) {
                if (arrayDeserts[i][j] > 0) {
                  arrayDeserts[i][j] = arrayDeserts[i][j] + res.price
                } else {
                  arrayDeserts[i][j] = res.price
                }
              }
            }
          })
          if (arrayDeserts[i][j] == null) {
            arrayDeserts[i][j] = ''
          }
        }
      }
      return arrayDeserts
    },
    setObject(dataArray, countName, typeName) {
      let datasetts = []
      for (let i = 0; i < countName; i++) {
        const dataset = {
          label: typeName[i],
          backgroundColor: this.bgColor(i),
          borderColor: ['#FFF'],
          data: dataArray[i],
        }
        datasetts = [...datasetts, dataset]
      }
      return datasetts
    },
  },
}
</script>
